const { options } = require('joi');
const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    enabled,
    delete: _delete
};

/**
 * Format an array of pulseAgeRates by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} pulseAgeRates - The array of pulseAgeRates to format.
 * @returns {Promise<Object[]>} - The formatted array of pulseAgeRates.
 */
const formatWithModifier = async (pulseAgeRates) => {
    return Promise.all(
        pulseAgeRates.map(async (pulseAgeRate) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: pulseAgeRate.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...pulseAgeRate,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Get all pulseAgeRates with their respective companies.
 * @param {Object} params - An object that contains parameters to filter the pulseAgeRates.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the pulseAgeRates and a success flag.
 * @example
 * const result = await getAll({ companiesId: [1, 2] });
 * console.log(result);
 */
async function getAll(params) {
    try {
        // filter
        const filterConditions = {};

        if (params.companiesId) {
            filterConditions.company_id = {
                [Op.in]: params.companiesId
            };
        }

        let pulseAgeRates = [];
        pulseAgeRates = await dbSAPPS.PulseAgeRate.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
            include: [
                {
                    model: dbSAPPS.Company,
                    as: 'company',
                    attributes: ['id', 'display_name']
                }
            ]
        });

        pulseAgeRates = pulseAgeRates.map(pulseAgeRate => {
            return {
                ...pulseAgeRate.dataValues,
                company_name: pulseAgeRate?.company?.display_name
            }
        });

        pulseAgeRates = await formatWithModifier(pulseAgeRates);

        return {
            pulseAgeRates,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage,
        };
    }
}

/**
 * Get pulseAgeRates with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the pulseAgeRates.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the pulseAgeRates and a success flag.
 * @example
 * const result = await option({ companiesId: [1, 2] });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        if (params.companiesId) {
            filterConditions.company_id = {
                [Op.in]: params.companiesId
            };
        }

        // must be enabled
        filterConditions.enabled = {
            [Op.eq]: true
        };

        let options = [];
        options = await dbSAPPS.PulseAgeRate.findAll({
            where: filterConditions,
            attributes: ['id', 'name', 'display_name'],
            include: [
                {
                    model: dbSAPPS.Company,
                    as: 'company',
                    attributes: ['id', 'name', 'display_name']
                }
            ],
            order: [['name', 'ASC']]
        });

        options = options.map(option => {
            return {
                ...option.dataValues,
                company_name: option?.company?.display_name
            }
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active pulseAgeRates
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */
async function count(params) {
    try {
        // filter
        const filterConditions = {};

        // must be enabled
        filterConditions.enabled = {
            [Op.eq]: true
        };

        const count = await dbSAPPS.PulseAgeRate.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new pulseAgeRate
 * 
 * @param {object} params - pulseAgeRate data to be created.
 * @param {string} params.name - pulseAgeRate name.
 * @param {string} params.display_name - pulseAgeRate display name.
 * @param {boolean} [params.enabled=true] - pulseAgeRate enabled status.
 * @param {number} [params.creation=Date.now()] - pulseAgeRate creation timestamp.
 * @param {number} [params.modified=Date.now()] - pulseAgeRate last modification timestamp.
 * @param {number} [params.owner=1] - User ID of the pulseAgeRate owner.
 * @param {number} [params.modified_by=1] - User ID of the last modifier of the pulseAgeRate.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the pulseAgeRate creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingAge = await dbSAPPS.PulseAgeRate.findOne({
            where: { age: params.age, company_id: params.company_id },
            transaction
        });
        if (existingAge) {
            return {
                success: false,
                message: `"${params.age}" is already taken.`
            };
        }

        // save
        await dbSAPPS.PulseAgeRate.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing pulseAgeRate
 * 
 * @param {number} id - pulseAgeRate ID to be updated.
 * @param {object} params - pulseAgeRate data to be updated.
 * @param {string} [params.name] - pulseAgeRate name.
 * @param {string} [params.display_name] - pulseAgeRate display name.
 * @param {boolean} [params.enabled] - pulseAgeRate enabled status.
 * @param {number} [params.creation] - pulseAgeRate creation timestamp.
 * @param {number} [params.modified] - pulseAgeRate last modification timestamp.
 * @param {number} [params.owner] - User ID of the pulseAgeRate owner.
 * @param {number} [params.modified_by] - User ID of the last modifier of the pulseAgeRate.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the pulseAgeRate update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const pulseAgeRate = await dbSAPPS.PulseAgeRate.findByPk(id);
        if (!pulseAgeRate) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingAge = await dbSAPPS.PulseAgeRate.findOne({
            where: {
                age: params.age,
                company_id: params.company_id,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingAge) {
            return {
                success: false,
                message: `"${params.age}" is already taken.`
            };
        }

        // save
        await pulseAgeRate.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Enable or disable a pulseAgeRate
 * @param {number} id - the id of the pulseAgeRate
 * @param {object} params - the update data
 * @param {boolean} params.enabled - the enabled status of the pulseAgeRate
 * @param {number} [params.modified_by] - the modified by of the pulseAgeRate
 * @param {Date} [params.modified] - the modified of the pulseAgeRate
 * @returns {Promise<object>} - the result of the update
 */
async function enabled(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const pulseAgeRate = await dbSAPPS.PulseAgeRate.findByPk(id);
        if (!pulseAgeRate) return { success: false, message: 'ID not found!' };

        // update params
        const updateData = {};
        updateData.enabled = params.enabled;
        if (params.modified_by) updateData.modified_by = params.modified_by;
        if (params.modified) updateData.modified = params.modified;

        // save
        await pulseAgeRate.update(updateData, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a pulseAgeRate
 * @param {number} id - the id of the pulseAgeRate
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const pulseAgeRate = await dbSAPPS.PulseAgeRate.findByPk(id, { transaction });
        if (!pulseAgeRate) return { success: false, message: 'ID not found!' };

        // delete
        await pulseAgeRate.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
